// TaskbarIcon.cpp
#include "TaskbarIcon.h"
enum {
    PU_RESTORE = 10001,
    PU_RUNNING,
    PU_EXIT,
    PU_STOPPED
};


BEGIN_EVENT_TABLE(MyTaskBarIcon, wxTaskBarIcon)
    EVT_MENU(PU_RESTORE, MyTaskBarIcon::OnMenuRestore)
    EVT_MENU(PU_EXIT,    MyTaskBarIcon::OnMenuExit)
    EVT_MENU(PU_RUNNING, MyTaskBarIcon::OnMenuRunning)
    EVT_MENU(PU_STOPPED, MyTaskBarIcon::OnMenuStopped)
    EVT_UPDATE_UI(PU_STOPPED,MyTaskBarIcon::OnMenuUIStopped)
    EVT_UPDATE_UI(PU_RUNNING,MyTaskBarIcon::OnMenuUIRunning)
    EVT_TASKBAR_LEFT_DCLICK  (MyTaskBarIcon::OnLeftButtonDClick)
END_EVENT_TABLE()

void MyTaskBarIcon::OnMenuRestore(wxCommandEvent& )
{
    frame->Show(true);
}

void MyTaskBarIcon::OnMenuExit(wxCommandEvent& )
{
    frame->Close(true);
}

void MyTaskBarIcon::OnMenuStopped(wxCommandEvent& )
{
	frame->SetConnected(false);
}

void MyTaskBarIcon::OnMenuUIStopped(wxUpdateUIEvent &event)
{
	event.Check( !g_connected );
}

void MyTaskBarIcon::OnMenuRunning(wxCommandEvent&)
{
	frame->SetConnected(true);
}

void MyTaskBarIcon::OnMenuUIRunning(wxUpdateUIEvent &event)
{
	event.Check( g_connected );
}

void MyTaskBarIcon::UpdateIcon(void)
{
	wxIcon iconCon(smile_xpm);
	if (g_connected)
		SetIcon(wxICON(ic_conn), wxT("wxTrax: Connected"));
	else
		SetIcon(wxICON(ic_disconn), wxT("wxTrax: Disconnected"));
}
	
// Overridables
wxMenu *MyTaskBarIcon::CreatePopupMenu()
{
    wxMenu *menu = new wxMenu;
    
    menu->Append(PU_RESTORE, _T("&Restore wxTray"));
    menu->Append(PU_RUNNING, _T("&Running"),wxT( "" ), wxITEM_CHECK );
    menu->Append(PU_STOPPED, _T("Stopped"), wxT( "" ), wxITEM_CHECK );
    menu->Append(PU_EXIT,    _T("E&xit"));

    return menu;
}

void MyTaskBarIcon::OnLeftButtonDClick(wxTaskBarIconEvent&)
{
    frame->Show(true);
}
